package com.weaver.seconddev.jcldoor.cmd;

import com.weaver.ebuilder.datasource.api.entity.SqlParamEntity;
import com.weaver.seconddev.jcldoor.util.DatabaseUtils;
import com.weaver.teams.domain.user.SimpleEmployee;
import com.weaver.teams.security.context.UserContext;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import javax.servlet.http.HttpServletRequest;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 自助服务入口
 *
 * @author wangj
 * @version 1.00版本
 * @Date 2024/3/19
 */
@Component
public class SelfServiceInfoCmd {
    //日志
    private final static Logger log = LoggerFactory.getLogger(SelfServiceInfoCmd.class);

    @Autowired
    private DatabaseUtils databaseUtils;

    public String tenant_key = "t7akvdnf84";

    public Map<String, Object> getInfo(HttpServletRequest request, SimpleEmployee simpleEmployee) {
        Map<String,Object> recordMap = new HashMap<String,Object>();
        String field_id = "977306579913818114" ;

        String groupId = "weaver-ebuilder-form-service";
        String sourceType = "LOGIC";

        String employeeId = request.getParameter("employeeId");

        if(StringUtils.isBlank(employeeId)){
            employeeId = String.valueOf(UserContext.getCurrentEmployeeId());
        }

        List<Map<String,Object>> dataList  = new ArrayList<Map<String,Object>>();
        try{
            String sql = " select distinct taby from uf_zzfwrkpz where ry=? and qy is not null and taby is not null and delete_type=0 and tenant_key =?";

            List<String> strlist = new ArrayList<>(100);
            strlist.add(employeeId);
            strlist.add(tenant_key);


            List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);
            Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);


            log.error("sql:"+sql);
            List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
            if(recordList.size()>0){
                // /api/file/preview?type=redirect&imgFormat=small&fileId=977697615197618177&module=ebuilderform&authModule=ebuilderform&source=form&fieldId=977686869110833154&customParam=%7B%22dataId%22%3A%22977697666574729218%22%7D&refId=977697666574729218&folderId=8120831157448215424
                dataList = getCustomeServiceData(groupId,sourceType,field_id,recordList,employeeId);
            }else{
                dataList = getDefaultServiceData(groupId,sourceType,field_id);
            }
        }catch (Exception e){
            log.error("testSapi51-Exception:"+e.getMessage());
        }
        recordMap.put("list",dataList);
        return recordMap;
    }

    public List<Map<String,Object>> getCustomeServiceData(String groupId,String sourceType,String field_id,List<Map<String,Object>> recordList,String employeeId){

        Map<String,String> optionMap = getCustomServiceTypeName(groupId,sourceType,employeeId);

        for(int i=0;i<recordList.size();i++){
            Map<String,Object> recordMap = recordList.get(i);
            String taby = String.valueOf(recordMap.get("taby"));
            log.error("getCustemSelfServiceType-taby:"+taby);

            String tabyName = optionMap.get(taby);
            List<Map<String,Object>> customList = getCustomeServiceDataByType(groupId,sourceType,taby,employeeId);

            log.error("getCustemSelfServiceType-tabyName:"+tabyName);
            log.error("getCustemSelfServiceType-taby:"+taby);
            recordMap.put("menus",customList);
            recordMap.put("name",tabyName);
        }
        return recordList;
    }

    public List<Map<String,Object>> getCustomeServiceDataByType(String groupId,String sourceType,String value,String employeeId){
        String sql = " select fwmc,fwdz,fwtb,taby from uf_zzfwrkpz where ry=? and qy is not null and taby is not null and taby=? and delete_type=0 and tenant_key = ?";
        log.info("getSelfServiceData--sql:"+sql);

        List<String> strlist = new ArrayList<>(100);
        strlist.add(employeeId);
        strlist.add(value);
        strlist.add(tenant_key);

        List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);
        Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);


        List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
        for(int i=0;i<recordList.size();i++){
            Map<String,Object> recordMap = recordList.get(i);
            String fwtb = String.valueOf(recordMap.get("fwtb"));
            String fwtburl = "";
            if(StringUtils.isNotBlank(fwtb)){
                fwtburl = "/api/file/preview?fileId="+fwtb+"&module=ebuilderform&authModule=ebuilderform&type=imgs&source=form&fieldId="+fwtb+"&imgFormat=small";
            }
            recordMap.put("fwtburl",fwtburl);
        }
        return recordList;
    }

    /***
     *  默认数据
     * @param groupId
     * @param sourceType
     * @return
     */
    public List<Map<String,Object>> getDefaultServiceData(String groupId,String sourceType,String field_id){

        String sql = " select name,value_key as taby from field_option where field_id=? and  delete_type=0 and tenant_key = ?";
        log.info("sql:"+sql);

        List<String> strlist = new ArrayList<>(100);
        strlist.add(field_id);
        strlist.add(tenant_key);

        List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);
        Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);

        List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
        for(int i=0;i<recordList.size();i++){
            Map<String,Object> recordMap = recordList.get(i);
            String taby = String.valueOf(recordMap.get("taby"));
            List<Map<String,Object>> defaultList =  getDefaultServiceDataByType(groupId,sourceType,taby);
            recordMap.put("menus",defaultList);
        }
        return recordList;
    }

    /***
     * 默认数据
     * @param groupId
     * @param sourceType
     * @param value
     * @return
     */
    public List<Map<String,Object>> getDefaultServiceDataByType(String groupId,String sourceType,String value){
        String sql =" select t.taby,t.fwtb,t.fwmc,t.fwdz\n" +
                " from uf_zzfwcsh t \n" +
                " where t.delete_type=0 \n" +
                " and t.taby= ?" +
                " and t.tenant_key = ?";

        log.error("getSelfServiceData--sql:"+sql);

        List<String> strlist = new ArrayList<>(100);
        strlist.add(value);
        strlist.add(tenant_key);

        List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);
        Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);

        List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
        for(int i=0;i<recordList.size();i++){
            Map<String,Object> recordMap = recordList.get(i);
            String fwtb = String.valueOf(recordMap.get("fwtb"));
            String fwtburl = "";
            if(StringUtils.isNotBlank(fwtb)){
                fwtburl = "/api/file/preview?fileId="+fwtb+"&module=ebuilderform&authModule=ebuilderform&type=imgs&source=form&fieldId="+fwtb+"&imgFormat=small";
            }
            recordMap.put("fwtburl",fwtburl);
        }
        return recordList;
    }

    /***
     *
     * @param groupId
     * @param sourceType
     * @return
     */
    public Map<String,String> getCustomServiceTypeName(String groupId,String sourceType,String employeeId){

        Map<String,String> optionMap = new HashMap<String,String>();
        String sql = " select id,tabymmc from uf_zzfwrktaby where qy is not null and ry=? and delete_type=0 and tenant_key = ?";
        log.error("getCustomServiceTypeName-sql:"+sql);

        List<String> strlist = new ArrayList<>(100);
        strlist.add(employeeId);
        strlist.add(tenant_key);

        List<SqlParamEntity> sqlparam = databaseUtils.getSqlParamEntity(strlist);
        Map<String, Object> result = databaseUtils.executeForQuery(sourceType, groupId, sql,sqlparam);

        List<Map<String,Object>> recordList = databaseUtils.getDataSourceList(result);
        for(int i=0;i<recordList.size();i++){
            Map<String,Object> recordMap = recordList.get(i);
            String value = String.valueOf(recordMap.get("id"));
            String name = String.valueOf(recordMap.get("tabymmc"));
            log.error("getCustomServiceTypeName-value:"+value+" name:"+name);
            optionMap.put(value,name);
        }
        return optionMap;
    }

}
